<template>
  <div id="app">
    <h1 class="title">Infographic</h1>
    <p>COUNTRIES OF THE WORLD</p>
    <div class="filters">
      <h2>Only show:</h2>
      <span v-for="(filt, ix) in filters" :key="ix">
        <a v-if="ix !== selectedFilter" href="#" @click="setFilter(ix, filt.filter)">{{ filt.text }}</a>
      </span>
      <div class="currentlyShowing">
        Currently showing {{ filters[selectedFilter].text }}
      </div>
    </div>
    <Map />
    <profile v-if="hasSelectedState">
    </profile>
    <list v-else>
    </list>
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import Map from './components/Map.vue'
import Profile from './components/Profile.vue'
import List from './components/List.vue'

export default {
  name: 'app',
  data: function () {
    return {
      'selectedFilter': 0,
      'filters': [
        {
          'filter': {},
          'text': 'All'
        },
        {
          'filter': {
            'Continent': 'AF'
          },
          'text': 'Only Africa'
        },
        {
          'filter': {
            'Continent': 'AS'
          },
          'text': 'Only Asia'
        },
        {
          'filter': {
            'Continent': 'NA'
          },
          'text': 'Only North America'
        },
        {
          'filter': {
            'Continent': 'SA'
          },
          'text': 'Only South America'
        },
        {
          'filter': {
            'Continent': 'EU'
          },
          'text': 'Only Europe'
        },
        {
          'filter': {
            'Developed / Developing Countries': 'Developed'
          },
          'text': 'Developed Countries'
        },
        {
          'filter': {
            'Developed / Developing Countries': 'Developing'
          },
          'text': 'Developing Countries'
        }
      ]
    };
  },
  components: {
    Map,
    Profile,
    List
  },
  mounted: function () {
    this.$store.dispatch('loadCodes');
    this.$store.dispatch('loadArticles');
  },
  computed: {
    ...mapGetters([
      'hasSelectedState'
    ])
  },
  methods: {
    setFilter: function (ix, filter) {
      console.log(ix, filter);
      this.$store.commit('setFilter', filter);
      this.selectedFilter = ix;
    }
  }
}
</script>

<style>
#app {
  font-family: 'Avenir', Helvetica, Arial, sans-serif;
  -webkit-font-smoothing: antialiased;
  -moz-osx-font-smoothing: grayscale;
  text-align: left;
  color: #2c503e;
  margin-top: 60px;
  font-family: 'Georgia';
}

a {
  color: rgba(0, 160, 106, 1.0);
  text-decoration: none;
}

p {
  font-size: 110%;
}

h1 {
  font-family: 'Georgia';
}
h2 {
  font-weight: normal;
}

h1.title {
  border-bottom: 5px rgba(0, 160, 106, 1.0) solid
}

.filters {
  width: 100%;
  background: rgba(0, 160, 106, 1.0);
  color: white;
}
.filters h2 {
  display: inline-block;
  padding-right: 20px;
  padding-top: 0;
  padding-bottom: 0;
  margin-left: 5px;
  margin-top: 5px;
  margin-bottom: 5px;
}
.filters a {
  color: white;
  font-size: 120%;
  display: inline-block;
  border-bottom: thin white solid;
  margin-bottom: 9px;
  margin-left: 6px;
  margin-right: 6px;
  font-style: italic;
}
.currentlyShowing {
  display: inline-block;
  float: right;
  font-size: 140%;
  margin-top: 6px;
  margin-bottom: 6px;
  margin-left: 6px;
  margin-right: 6px;
}
</style>
